import * as functions from 'firebase-functions';
import type { AuthData } from 'firebase-functions/lib/common/providers/https';
import { type ILogger } from '../logger';
import { type Flatten } from '../utils';
import type { ITypeBuilder } from '../typeBuilder';
export interface FirebaseFunction<Parameters, ReturnType> {
    parametersBuilder: ITypeBuilder<Flatten<Parameters>, Parameters>;
    execute(parameters: Parameters): Promise<ReturnType>;
}
export type FirebaseFunctionConstructor<Parameters, ReturnType> = new (auth: AuthData | null, logger: ILogger) => FirebaseFunction<Parameters, ReturnType>;
export declare namespace FirebaseFunction {
    function create<Parameters, ReturnType>(FirebaseFunction: FirebaseFunctionConstructor<Parameters, ReturnType>, macKey: Uint8Array, regions?: string[]): functions.HttpsFunction & functions.Runnable<unknown>;
}
