import * as functions from 'firebase-functions';
import { type ILogger } from '../logger';
import { type Flatten } from '../utils';
import type { ITypeBuilder } from '../typeBuilder';
export interface FirebaseRequest<Parameters, ReturnType> {
    parametersBuilder: ITypeBuilder<Flatten<Parameters>, Parameters>;
    execute(parameters: Parameters): Promise<ReturnType>;
}
export type FirebaseRequestConstructor<Parameters, ReturnType> = new (logger: ILogger) => FirebaseRequest<Parameters, ReturnType>;
export declare namespace FirebaseRequest {
    function create<Parameters, ReturnType>(FirebaseRequest: FirebaseRequestConstructor<Parameters, ReturnType>, macKey: Uint8Array, regions?: string[]): functions.HttpsFunction;
}
